package eu.jonahbauer.raytracing.math;

import eu.jonahbauer.raytracing.render.spectrum.SampledWavelengths;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

public record Ray(@NotNull Vec3 origin, @NotNull Vec3 direction, @NotNull SampledWavelengths lambda) {
    public Ray {
        Objects.requireNonNull(origin, "origin");
        Objects.requireNonNull(direction, "direction");
        Objects.requireNonNull(lambda, "lambda");
    }

    public Ray(@NotNull Vec3 origin, @NotNull Vec3 direction) {
        this(origin, direction, SampledWavelengths.EMPTY);
    }

    public @NotNull Vec3 at(double t) {
        return Vec3.fma(t, direction, origin);
    }
}
