package eu.jonahbauer.raytracing.render.spectrum;

import org.jetbrains.annotations.NotNull;

public record ScaledSpectrum(@NotNull Spectrum spectrum, double scale) implements Spectrum {
    @Override
    public double max() {
        return spectrum.max() * scale;
    }

    @Override
    public double get(double lambda) {
        return spectrum.get(lambda) * scale;
    }
}
